FAILED_TESTS=""
TEST_NUMBER=1

run_executable () {
  echo "${TEST_NUMBER}. $1"
  ./$1
  if [ ! $? = 0 ]; then
    echo "!!! FAILED !!!"
    FAILED_TESTS="${FAILED_TEST} $1"
  fi
  TEST_NUMBER=`expr 1 + ${TEST_NUMBER}`
}

./dropDatabase >/dev/null

run_executable createDatabase
run_executable insertRecords
run_executable changeSchema
run_executable readRecords
run_executable updateRecords
run_executable update_with_transaction
run_executable deleteRecords
run_executable dropDatabase

run_executable createDatabase_c
run_executable changeSchema_c
run_executable insertRecords_c
run_executable readRecords_c
run_executable ormap_c
run_executable updateRecords_c
run_executable update_with_transaction_c
run_executable deleteRecords_c
run_executable connection_pool_c
run_executable dropDatabase_c
run_executable query_c

echo ""
if [ ${#FAILED_TESTS} = 0 ]; then
  echo "All examples succeeded."
  exit 0
else
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "!!! Some examples failed !!!"
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo ${FAILED_TEST}
  exit 1
fi
